@ ECHO off > \dev\nul
  IF NOT ""=="%batdbg%" ECHO %batdbg%
  REM --------------------------------------------------------------------------
  REM MEM.BAT  V1.29  (C) 1996-1997 by Matthias Paul
  REM                                 [Matthias.Paul@post.rwth-aachen.de]
  REM Wrapper for Novell DOS 7 and Caldera OpenDOS 7.01 MEM.EXE, to emulate
  REM MS-DOS' MEM /FR[EE] and /MO[DULE] parameters at its best and provide
  REM new /R[EGION] and /V[ECTORS] parameters. Output redirection is not
  REM fully supported with COMMAND.COM.
  REM Should run with any DOS 3.3+ COMMAND.COM (4DOS 4.0+, NDOS 7.0+),
  REM switching to fed their individual requirements. Needs MEM.EXE, FIND,
  REM and COMMAND to be in the %Path%.
  REM
  REM Spanish messages translated by Ciriaco Garca de Celis. Thanks, Ciri!
  REM
  REM Last edit: 1997-04-11 -mp
  REM --------------------------------------------------------------------------
  IF "4"=="%@Eval[2 + 2]%" LOADBTM on > \dev\nul
  IF "_free_"=="%1" GOTO free_region
  IF "_region_"=="%1" GOTO free_region
  IF "_help_"=="%1" GOTO free_region
  IF "_language_"=="%1" GOTO language
  IF "_exec_"=="%1" GOTO exec
  IF "_ver_"=="%1" GOTO getver
  SET CmdLine=> \dev\nul
  SET params=%1 %2 %3 %4 %5 %6 %7 %8 %9> \dev\nul
  IF ""=="%1" GOTO load
  SET param1=%1> \dev\nul
  IF ""=="%tmp%" SET tmp=%Temp%> \dev\nul
  IF NOT ""=="%tmp%" IF NOT EXIST %tmp%\nul MD %tmp% > \dev\nul
  BREAK on > \dev\nul
  IF EXIST %tmp%\swc.btm ECHO Warning: "%tmp%\swc.btm" is locked by another task. Waiting for release...
  IF NOT EXIST %tmp%\swc.btm IF EXIST %tmp%\mem0.$$$ ECHO Warning: "%tmp%\mem0.$$$" is locked by another task.
  IF "4"=="%@Eval[2 + 2]%" IF NOT EXIST %tmp%\swc.btm IF EXIST %tmp%\mem1.$$$ ECHO Warning: "%tmp%\mem1.$$$" is locked by another task.
  :wait1
  IF EXIST %tmp%\swc.btm GOTO wait1
  IF EXIST %tmp%\mem0.$$$ GOTO wait1
  IF "4"=="%@Eval[2 + 2]%" IF EXIST %tmp%\mem1.$$$ GOTO wait1
  BREAK off > \dev\nul
  IF NOT "4"=="%@Eval[2 + 2]%" GOTO no4dos
  ECHOS `SET `> %tmp%\swc.btm
  SETDOS | @ CALL FIND "SWITCH=" >> %tmp%\swc.btm
@ CALL %tmp%\swc.btm > \dev\nul
  DEL %tmp%\swc.btm > \dev\nul
  GOTO anydos
  :no4dos
  REM Check for undocumented feature of Caldera OpenDOS 7.01, Novell DOS 7,
  REM DR DOS 6.0 COMMAND.COM: If current SwitChar is not '/', the 1st '\'
  REM from CD/CHDIR and PROMPT $p path-output is replaced by '/'.
  REM Since DR DOS 6.0 COMMAND.COM prior to updates 1992 did copy
  REM files with zero length, this should not be enabled for original
  REM DR DOS 6.0 COMMAND.COM of 1991.
  REM IF "DRDOS"=="%Os%" IF "6.0"=="%Ver%" GOTO drdos6
  IF NOT "NWDOS"=="%Os%" IF NOT "OPENDOS"=="%Os%" GOTO anydos
  :drdos6
  CD | CALL FIND "/" > %tmp%\swc.btm
  IF NOT EXIST %tmp%\swc.btm GOTO anydos
  IF EXIST %tmp%\swc.btm COPY %tmp%\swc.btm %tmp%\mem0.$$$ > \dev\nul
  IF EXIST %tmp%\swc.btm DEL %tmp%\swc.btm > \dev\nul
  IF EXIST %tmp%\mem0.$$$ IF ""=="%switchar%" SET switch=-> \dev\nul
  IF NOT EXIST %tmp%\mem0.$$$ SET switch=> \dev\nul
  IF EXIST %tmp%\mem0.$$$ DEL %tmp%\mem0.$$$ > \dev\nul
  :anydos
  IF ""=="%switch%" SET switch=%switchar%> \dev\nul
  IF ""=="%switch%" SET switch=/> \dev\nul

  REM Check for Novell DOS 7 kernel...
  IF "NWDOS"=="%Os%" GOTO loop
  IF NOT ""=="%Os%" GOTO load
  BREAK on > \dev\nul
  IF EXIST %tmp%\mem.sem ECHO Warning: "%tmp%\mem.sem" is locked by another task. Waiting for release...
  :wait2
  IF EXIST %tmp%\mem.sem GOTO wait2
  BREAK off > \dev\nul
  ECHO Semaphore %0 > %tmp%\mem.sem
  REM The following block of unusual instructions works around a bug in
  REM MS-DOS 6.2x COMMAND.COM's CALL, occuring only with SHARE loaded and
  REM in redirection. Also, some problems with Novell COMMAND.COM features,
  REM unsupported under other command processors, are resolved.
  SET oldver=%Ver%> \dev\nul
  IF ""=="%Ver%" SET Ver=7> \dev\nul
@ %ComSpec% %switch%c COMMAND %switch%c %0 _ver_
  IF ""=="%oldver%" SET Ver=> \dev\nul
  SET oldver=> \dev\nul
  GOTO chkver
  :getver
  VER > %tmp%\mem0.$$$
  GOTO exit2
  :chkver
  REM Don't use "FIND text file" here, since this will always output the filename
  REM under MS-DOS...
  TYPE %tmp%\mem0.$$$ | %ComSpec% %switch%c FIND "Novell DOS 7" > %tmp%\mem1.$$$
  IF EXIST %tmp%\mem0.$$$ DEL %tmp%\mem0.$$$ > \dev\nul
  IF "4"=="%@Eval[2 + 2]%" IF "0"=="%@FileSize[%tmp%\mem1.$$$,b]%" (DEL %tmp%\mem1.$$$ > \dev\nul %+ GOTO load)
  IF EXIST %tmp%\mem1.$$$ COPY %tmp%\mem1.$$$ %tmp%\mem0.$$$ > \dev\nul
  IF EXIST %tmp%\mem1.$$$ DEL %tmp%\mem1.$$$ > \dev\nul
  IF NOT EXIST %tmp%\mem0.$$$ GOTO load
  DEL %tmp%\mem0.$$$ > \dev\nul

  :loop
  IF ""=="%1" GOTO load_nwdos
  FOR %%x IN (fr FR Fr free FREE Free) DO IF "%%x"=="%1" GOTO free
  FOR %%x IN (fr FR Fr free FREE Free) DO IF "%switch%%%x"=="%1" GOTO free
  FOR %%x IN (r R re RE Re region REGION Region) DO IF "%%x"=="%1" GOTO region
  FOR %%x IN (r R re RE Re region REGION Region) DO IF "%switch%%%x"=="%1" GOTO region
  FOR %%x IN (mo MO Mo module MODULE Module) DO IF "%%x"=="%1" GOTO module
  FOR %%x IN (mo MO Mo module MODULE Module) DO IF "%switch%%%x"=="%1" GOTO module
  FOR %%x IN (m= M= mo= MO= Mo= module= MODULE= Module=) DO IF "%%x"=="%1" GOTO module
  FOR %%x IN (m= M= mo= MO= Mo= module= MODULE= Module=) DO IF "%switch%%%x"=="%1" GOTO module
  FOR %%x IN (v V ve VE Ve vectors VECTORS Vectors) DO IF "%%x"=="%1" GOTO vectors
  FOR %%x IN (v V ve VE Ve vectors VECTORS Vectors) DO IF "%switch%%%x"=="%1" GOTO vectors
  FOR %%x IN (v= V= ve= VE= Ve= vectors= VECTORS= Vectors=) DO IF "%%x"=="%1" GOTO vectors
  FOR %%x IN (v= V= ve= VE= Ve= vectors= VECTORS= Vectors=) DO IF "%switch%%%x"=="%1" GOTO vectors
  SHIFT
  GOTO loop

  :free
  REM Inside FOR loops Novell's COMMAND.COM does not accept '@' in front of commands...
@ MEM.BAT _free_

  :region
  REM Inside FOR loops Novell's COMMAND.COM does not accept '@' in front of commands...
@ MEM.BAT _region_

  :language
  REM Check for Novell DOS 7 MEM language...
  SHIFT
@ MEM.EXE %switch%H | CALL FIND "%2" > %tmp%\mem0.$$$
  IF EXIST %tmp%\mem1.$$$ DEL %tmp%\mem1.$$$ > \dev\nul
  IF "4"=="%@Eval[2 + 2]%" IF "0"=="%@FileSize[%tmp%\mem0.$$$,b]%" (DEL %tmp%\mem0.$$$ > \dev\nul %+ GOTO %4)
  IF EXIST %tmp%\mem0.$$$ COPY %tmp%\mem0.$$$ %tmp%\mem1.$$$ > \dev\nul
  IF EXIST %tmp%\mem0.$$$ DEL %tmp%\mem0.$$$ > \dev\nul
  IF NOT EXIST %tmp%\mem1.$$$ GOTO %4
  DEL %tmp%\mem1.$$$ > \dev\nul
  GOTO %3

  :free_region
  REM Check for MEM messages localization...
@ MEM.BAT _language_ %1 reserved U not_U
  :not_U
@ MEM.BAT _language_ %1 rservs F not_F
  :not_F
@ MEM.BAT _language_ %1 Reservados S not_S
  :not_S
@ MEM.BAT _language_ %1 riservati I not_I
  :not_I
@ MEM.BAT _language_ %1 vorbehalten G not_G
  :not_G
  REM @ MEM.BAT _language_ %1 xxxx J not_J
  REM :not_J
  REM Normally will not come here... But, since this is an example, the
  REM following detection methods still have been left here...

  REM Check kernel localization...
  FOR %%x IN (morning afternoon evening) DO IF "%%x"=="%Greeting_Time%" GOTO U
  FOR %%x IN (Bonjour Bonsoir) DO IF "%%x"=="%Greeting_Time%" GOTO F
  FOR %%x IN (maana tarde noche) DO IF "%%x"=="%Greeting_Time%" GOTO S
  FOR %%x IN (giorno pomeriggio sera) DO IF "%%x"=="%Greeting_Time%" GOTO I
  FOR %%x IN (Morgen Tag Abend) DO IF "%%x"=="%Greeting_Time%" GOTO G
  REM FOR %%x IN (xxxx xxxx xxxx) DO IF "%%x"=="%Greeting_Time%" GOTO J

  REM Check NWLANGUAGE variable (used by PNW & NetWare)...
  IF "ENGLISH"=="%nwlanguage%" GOTO U
  REM (Adapt to actual country specific strings, here!!!)
  IF "FRANAIS"=="%nwlanguage%" GOTO F
  IF "FRANCAIS"=="%nwlanguage%" GOTO F
  IF "ESPAOL"=="%nwlanguage%" GOTO S
  IF "ESPANOL"=="%nwlanguage%" GOTO S
  IF "ITALIANO"=="%nwlanguage%" GOTO I
  IF "DEUTSCH"=="%nwlanguage%" GOTO G
  REM IF "NIHON"=="%nwlanguage%" GOTO J
  REM IF "NIHONGO"=="%nwlanguage%" GOTO J

  REM 4DOS/NDOS provides a system info variable %_Country%!
  REM Some examples, adapt this to country specific phone codes...
  FOR %%x IN (1 4 7 30 31 32 36 38 40 42 44 45 46 47 48 52 61 64 90 351 353 354) DO IF "%%x"=="%_Country%" GOTO U
  FOR %%x IN (33 2) DO IF "%%x"=="%_Country%" GOTO F
  FOR %%x IN (34 3 27 54 55 56 57 58 60) DO IF "%%x"=="%_Country%" GOTO S
  FOR %%x IN (39) DO IF "%%x"=="%_Country%" GOTO I
  FOR %%x IN (49 41 43) DO IF "%%x"=="%_Country%" GOTO G
  REM FOR %%x IN (81) DO IF "%%x"=="%_Country%" GOTO J

  IF "_help_"=="%1" GOTO help_U
  ECHO Error: Your language is not supported by this batchjob
  IF ""=="%nwlanguage%" ECHO        or environment variables NWLANGUAGE or _COUNTRY not specified.
  ECHO        Adapt to your country or use %switch%MODULE [translation of "Free"] instead!
  GOTO exit

  :U
@ IF "_free_"=="%1" MEM.BAT _exec_ %switch%A "Free"
@ IF "_region_"=="%1" MEM.BAT _exec_ %switch%U "-- Upper RAM --"
@ IF "_help_"=="%1" GOTO help_U
  GOTO exit
  :F
@ IF "_free_"=="%1" MEM.BAT _exec_ %switch%A "Libre"
@ IF "_region_"=="%1" MEM.BAT _exec_ %switch%U "-- Mmoire haute --"
@ IF "_help_"=="%1" GOTO help_F
  GOTO exit
  :S
@ IF "_free_"=="%1" MEM.BAT _exec_ %switch%A "Libre"
@ IF "_region_"=="%1" MEM.BAT _exec_ %switch%U "-- RAM Superior --"
@ IF "_help_"=="%1" GOTO help_S
  GOTO exit
  :I
@ IF "_free_"=="%1" MEM.BAT _exec_ %switch%A "Libera"
@ IF "_region_"=="%1" MEM.BAT _exec_ %switch%U "-- RAM superiore --"
@ IF "_help_"=="%1" GOTO help_I
  GOTO exit
  :G
@ IF "_free_"=="%1" MEM.BAT _exec_ %switch%A "Frei"
@ IF "_region_"=="%1" MEM.BAT _exec_ %switch%U "-- Oberes RAM --"
@ IF "_help_"=="%1" GOTO help_G
  GOTO exit

  REM :J
  REM @ IF "_free_"=="%1" MEM.BAT _exec_ %switch%A "xxxx"
  REM @ IF "_region_"=="%1" MEM.BAT _exec_ %switch%U "-- xxxx --"
  REM @ IF "_help_"=="%1" GOTO help_J
  REM GOTO exit

  :exec
  IF EXIST %tmp%\mem.sem DEL %tmp%\mem.sem > \dev\nul
@ MEM.EXE %2 | CALL FIND %3 %4 %5 %6 %7 %8 %9
  GOTO end

  :module
  IF EXIST %tmp%\mem.sem DEL %tmp%\mem.sem > \dev\nul
  IF ""=="%2" GOTO full
  FOR %%x IN (: = :=  ) DO IF "%%x"=="%2" IF NOT ""=="%3" SHIFT
@ MEM.EXE %switch%A | CALL FIND "%2"
  GOTO end
  :full
@ MEM.EXE %switch%A
  GOTO end

  :vectors
  IF EXIST %tmp%\mem.sem DEL %tmp%\mem.sem > \dev\nul
  REM Create a DEBUG script containing some special commands, only accepted
  REM by Novell DOS 7 DEBUG...
  BREAK on > \dev\nul
  IF EXIST %tmp%\mem.scr ECHO Warning: "%tmp%\mem.scr" is locked by another task. Waiting for release...
  :wait3
  IF EXIST %tmp%\mem.scr GOTO wait3
  BREAK off > \dev\nul
  ECHO /X > %tmp%\mem.scr
  IF ""=="%2" GOTO v_full
  ECHO -D 4 >> %tmp%\mem.scr
  REM Create 0..255 DI commands...
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr

  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr

  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr
  FOR %%x IN (0 1 2 3 4 5 6 7 8 9) DO ECHO DI >> %tmp%\mem.scr

  FOR %%x IN (0 1 2 3 4 5) DO ECHO DI >> %tmp%\mem.scr
  ECHO Q >> %tmp%\mem.scr
  FOR %%x IN (: = :=  ) DO IF "%%x"=="%2" IF NOT ""=="%3" SHIFT
@ DEBUG.EXE < %tmp%\mem.scr | CALL FIND "%2"
  :v_end
@ DEL %tmp%\mem.scr > \dev\nul
  GOTO end
  :v_full
  ECHO DI 0 L 100 >> %tmp%\mem.scr
  ECHO Q >> %tmp%\mem.scr
@ DEBUG.EXE < %tmp%\mem.scr | CALL FIND "Int"
  GOTO v_end

  :load
  IF EXIST %tmp%\mem.sem DEL %tmp%\mem.sem > \dev\nul
@ MEM.EXE %params%
  GOTO end

  :load_nwdos
  IF EXIST %tmp%\mem.sem DEL %tmp%\mem.sem > \dev\nul
@ MEM.EXE %params%
  IF "/?"=="%param1%" MEM.BAT _help_
  IF "%switch%?"=="%param1%" MEM.BAT _help_
  FOR %%x IN (h H) DO IF "/%%x"=="%param1%" MEM.BAT _help_
  FOR %%x IN (h H) DO IF "%switch%%%x"=="%param1%" MEM.BAT _help_
  FOR %%x IN (help HELP Help) DO IF "%switch%%%x"=="%param1%" MEM.BAT _help_
  GOTO end

  :help_U
  ECHO.
  ECHO %switch%FR[EE]                 Lists all free memory areas (as with MS-DOS/PC-DOS).
  ECHO %switch%MO[DULE][=] [program]  Lists all memory areas allocated by device driver/
  ECHO                         TSR (without extension) (as with MS-DOS/PC-DOS).
  ECHO %switch%R[EGION]               Lists UMB memory region info.
  ECHO %switch%V[ECTORS][=] [intr[-]] Lists all interrupts (containing "intr[-]").
  ECHO.
  GOTO exit

  :help_F
  GOTO help_U

  :help_S
  ECHO.
  ECHO %switch%FR[EE]                 Listado de reas de memoria libres (tipo MS-DOS/PC-DOS)
  ECHO %switch%MO[DULE][=] [programa] Listado de reas de memoria ocupadas por controladores
  ECHO                         de dispositivo/TSR (sin extensin) (tipo MS-DOS/PC-DOS)
  ECHO %switch%R[EGION]               Listado con informacin de la regin UMB.
  ECHO %switch%V[ECTORS][=] [intr[-]] Listado de las interrupciones (conteniendo "intr[-]").
  ECHO.
  GOTO exit

  :help_I
  :help_J
  GOTO help_U

  :help_G
  ECHO.
  ECHO %switch%FR[EE]                 Listet alle freien Speicherbereiche (wie bei MS-DOS).
  ECHO %switch%MO[DULE][=] [treiber]  Listet alle Speicherbereiche, die von dem Treiber
  ECHO                         (ohne Erweiterung) belegt werden (wie bei MS-DOS).
  ECHO %switch%R[EGION]               Listet UMB-Bereichsinformationen.
  ECHO %switch%V[ECTORS][=] [intr[-]] Listet alle Interrupts auf (die "intr[-]" enthalten).
  ECHO.

  :exit
  IF EXIST %tmp%\mem.sem DEL %tmp%\mem.sem > \dev\nul
  :end
  SET CmdLine=> \dev\nul
  SET params=> \dev\nul
  SET param1=> \dev\nul
  REM SET switch=> \dev\nul
  :exit2
  REM Avoid a parsing bug in an older MS-DOS COMMAND.COM release...
  REM
